import trafficSimulator as ts

sim = ts.Simulation()

lane_space = 3.5
intersection_size = 12
length = 100

# SOUTH, EAST, NORTH, WEST

# Intersection in
sim.create_segment(
    (lane_space / 2, length + intersection_size / 2),
    (lane_space / 2, intersection_size / 2)
)
sim.create_segment(
    (length + intersection_size / 2, -lane_space / 2),
    (intersection_size / 2, -lane_space / 2)
)
sim.create_segment(
    (-lane_space / 2, -length - intersection_size / 2),
    (-lane_space / 2, -intersection_size / 2)
)
sim.create_segment(
    (-length - intersection_size / 2, lane_space / 2),
    (-intersection_size / 2, lane_space / 2)
)
# Intersection out
sim.create_segment(
    (-lane_space / 2, intersection_size / 2),
    (-lane_space / 2, length + intersection_size / 2)
)
sim.create_segment(
    (intersection_size / 2, lane_space / 2),
    (length + intersection_size / 2, lane_space / 2)
)
sim.create_segment(
    (lane_space / 2, -intersection_size / 2),
    (lane_space / 2, -length - intersection_size / 2)
)
sim.create_segment(
    (-intersection_size / 2, -lane_space / 2),
    (-length - intersection_size / 2, -lane_space / 2)
)
# Straight
sim.create_segment(
    (lane_space / 2, intersection_size / 2),
    (lane_space / 2, -intersection_size / 2)
)
sim.create_segment(
    (intersection_size / 2, -lane_space / 2),
    (-intersection_size / 2, -lane_space / 2)
)
sim.create_segment(
    (-lane_space / 2, -intersection_size / 2),
    (-lane_space / 2, intersection_size / 2)
)
sim.create_segment(
    (-intersection_size / 2, lane_space / 2),
    (intersection_size / 2, lane_space / 2)
)
# Right turn
sim.create_quadratic_bezier_curve(
    (lane_space / 2, intersection_size / 2),
    (lane_space / 2, lane_space / 2),
    (intersection_size / 2, lane_space / 2)
)
sim.create_quadratic_bezier_curve(
    (intersection_size / 2, -lane_space / 2),
    (lane_space / 2, -lane_space / 2),
    (lane_space / 2, -intersection_size / 2)
)
sim.create_quadratic_bezier_curve(
    (-lane_space / 2, -intersection_size / 2),
    (-lane_space / 2, -lane_space / 2),
    (-intersection_size / 2, -lane_space / 2)
)
sim.create_quadratic_bezier_curve(
    (-intersection_size / 2, lane_space / 2),
    (-lane_space / 2, lane_space / 2),
    (-lane_space / 2, intersection_size / 2)
)
# Left turn
sim.create_quadratic_bezier_curve(
    (lane_space / 2, intersection_size / 2),
    (lane_space / 2, -lane_space / 2),
    (-intersection_size / 2, -lane_space / 2)
)
sim.create_quadratic_bezier_curve(
    (intersection_size / 2, -lane_space / 2),
    (-lane_space / 2, -lane_space / 2),
    (-lane_space / 2, intersection_size / 2)
)
sim.create_quadratic_bezier_curve(
    (-lane_space / 2, -intersection_size / 2),
    (-lane_space / 2, lane_space / 2),
    (intersection_size / 2, lane_space / 2)
)
sim.create_quadratic_bezier_curve(
    (-intersection_size / 2, lane_space / 2),
    (lane_space / 2, lane_space / 2),
    (lane_space / 2, -intersection_size / 2)
)

vg = ts.VehicleGenerator({
    'vehicles': [
        (1, {'path': [0, 8, 6], 'v': 16.6}),
        (1, {'path': [0, 12, 5], 'v': 16.6})
    ]
})
sim.add_vehicle_generator(vg)

win = ts.Window(sim)
win.run()
win.show()
